import os
from inventory_provider import netconf
from lxml import etree

TEST_DATA_DIR = os.path.join(os.path.dirname(__file__), 'data')

class MockedJunosRpc(object):

    def __init__(self, hostname):
        filename = os.path.join(TEST_DATA_DIR, "%s-netconf.xml" % hostname)
        self.config = etree.parse(filename)

    def get_config(self):
        return self.config


class MockedJunosDevice(object):

    def __init__(self, **kwargs):
        self.rpc = MockedJunosRpc(kwargs['host'])

    def open(self):
        pass


def test_nr1(mocker, data_config):
    mocker.patch(
        'inventory_provider.netconf.Device',
        MockedJunosDevice)

    import json
    for r in data_config['routers']:
        print(r['hostname'])
        x = netconf.load_interfaces(r['hostname'], data_config['ssh'])
        print(json.dumps(list(x), indent=4))
